package org.eclipse.cdt.core.model;

import org.eclipse.cdt.core.model.CModelException;
import org.eclipse.cdt.core.model.ICElement;
import org.eclipse.cdt.core.model.IOpenable;
import org.eclipse.cdt.core.model.IParent;

/**
 * @author jwoo
 *
 */
public interface IHardwareSpec extends ICElement {
	
	/**
	 * Returns the all the processors of this container.
	 * 
	 * @return
	 * @throws CModelException
	 */
//	IProcessor[] getProcessors() throws CModelException;
	
	/**
	 * Return the processor for this name.
	 * 
	 * @return
	 * @throws CModelException
	 */
//	IProcessor getProcessor(String name);
	
	/**
	 * Returns hardware specification file name.
	 * 
	 * @return
	 */
	String getName();
	
	/**
	 * Returns hardware specification description.
	 * 
	 * @return
	 */
	String getDescription();

}
